fun printAexp (W.CstR r)        fnm = Real.toString r
  | printAexp (W.Var  v)        fnm = "<a href=\"result.msp?prog="^fnm^"&variable="^v^"\" target=\"result\">"^v^"</a>"
  | printAexp (W.Plus (a1,a2))  fnm = printAexp a1 fnm ^ " + " ^ printAexp a2 fnm
  | printAexp (W.Minus (a1,a2)) fnm = printAexp a1 fnm ^ " - " ^ printAexp a2 fnm
  | printAexp (W.Times (a1,a2)) fnm = printAexp a1 fnm ^ " * " ^ printAexp a2 fnm
  | printAexp (W.Divide (a1,a2))fnm = printAexp a1 fnm ^ " / " ^ printAexp a2 fnm

fun printBexp (W.CstB b)      fnm = Bool.toString b
  | printBexp (W.LES (a1,a2)) fnm = printAexp a1 fnm ^ " <= "  ^ printAexp a2 fnm
  | printBexp (W.EQ (a1,a2))  fnm = printAexp a1 fnm ^ " = "   ^ printAexp a2 fnm
  | printBexp (W.GRT (a1,a2)) fnm = printAexp a1 fnm ^ " > "   ^ printAexp a2 fnm
  | printBexp (W.AND (b1,b2)) fnm = printBexp b1 fnm ^ " and " ^ printBexp b2 fnm
  | printBexp (W.OR (b1,b2))  fnm = printBexp b1 fnm ^ " or "  ^ printBexp b2 fnm
  | printBexp (W.NOT b)       fnm = "not " ^ printBexp b fnm

fun printLab (W.LSKIP l)         fnm ta = ta ^ "[skip]<font size=-1><sup>" ^
                                          "<a href=\"result.msp?prog=" ^ fnm ^ "&label=" ^ l ^ "\" target=\"result\">" ^
                                          l ^ "</a>" ^
                                          "</sup></font>"
  | printLab (W.LASGN (s,a,l))   fnm ta = ta ^ "["^"<a href=\"result.msp?prog=" ^ fnm ^ "&variable=" ^ s ^"\" target=\"result\">" ^
                                          s ^ "</a> := " ^ printAexp a fnm ^ "]<font size=-1><sup>" ^
                                          "<a href=\"result.msp?prog=" ^ fnm ^ "&label=" ^ l ^ "\" target=\"result\">" ^
                                          l ^ "</a>"^
                                          "</sup></font>"
  | printLab (W.LIF (b,l,s1,s2)) fnm ta = ta ^ "if [" ^ printBexp b fnm ^ "]<font size=-1><sup>" ^
                                          "<a href=\"result.msp?prog=" ^ fnm ^ "&label=" ^ l ^ "\" target=\"result\">" ^
                                          l ^ "</a>"^
                                          "</sup></font> then " ^
                                          printLab s1 fnm ta ^ " else " ^
                                          printLab s2 fnm ta
  | printLab (W.LWHILE (b,l,s))  fnm ta = ta ^ "while [" ^ printBexp b fnm ^ "]<font size=-1><sup>"^
                                         "<a href=\"result.msp?prog=" ^ fnm ^ "&label="^l^"\" target=\"result\">"^l^"</a>"^
                                         "</sup></font> do<br/>\n" ^ printLab s fnm "&nbsp;&nbsp;"
  | printLab (W.LCOMP (s1,s2))   fnm ta = ta ^ printLab s1 fnm ta ^ " ;<br/>\n" ^
                                          ta ^ printLab s2 fnm ta

fun prettyPrint fil fnm = printLab fil fnm ""
