open Socket

fun sendMsg conn text =
    let
      val buf = {buf = Byte.stringToBytes text,
                 ofs = 0, size = NONE}
      val _   = ignore(sendVec(conn, buf))
      val msg = Byte.bytesToString (recvVec(conn, 3))
    in
      if msg = "ack" then () else print ("Send msg: \"" ^ text ^ "\", recieved: \"" ^ msg ^ "\" on socket.")
    end

fun recvMsg conn =
    let
      val msg = recvVec(conn, 1000)
      val buf = {buf = Byte.stringToBytes "ack",
                 ofs = 0, size = SOME(3)}
      val _   = ignore(sendVec(conn, buf))
    in
      Byte.bytesToString msg
    end

fun sendSock port msgl recv =
let
    val localhost = "127.0.0.1"
    val addr = inetAddr localhost port
    val sock = inetStream()

    fun call () =
    let
        val _    = Socket.connect(sock, addr)
        val text = recvMsg sock
    in
        List.app (sendMsg sock) msgl;
        (if recv then print (recvMsg sock) else ());
        close sock
    end
    handle x => (close sock; raise x)

in
    call ()
end
handle OS.SysErr (msg, _) => raise Fail (msg ^ "\n")

